/******************************************************************************
Module:  LSAStr.h
Notices: Copyright (c) 2000 Jeffrey Richter
******************************************************************************/
#pragma once 

#include "Ntsecapi.h"

class CLSAStr : public LSA_UNICODE_STRING {
public:
   CLSAStr();
   CLSAStr(PWSTR pstr);
   CLSAStr(LSA_UNICODE_STRING &lsastr);
   CLSAStr(PLSA_UNICODE_STRING plsastr);
   CLSAStr(CLSAStr &lsaStr);

   ~CLSAStr(); ;

   operator PWSTR() {return(Buffer); }
   operator =(LSA_UNICODE_STRING &lsastr) { AssignLSAStr(&lsastr); return NULL; }
   operator =(PLSA_UNICODE_STRING plsastr) { AssignLSAStr(plsastr); }
   operator =(PWSTR pstr) { AssignString(pstr); return NULL;}

private:
   void ResetInstance(BOOL fConstructing = FALSE);

   void AssignString(PWSTR pstr);

   void AssignLSAStr(PLSA_UNICODE_STRING plsastr);

   BOOL AdjustBuffer(USHORT nMax);
};


///////////////////////////////// End of File /////////////////////////////////